package net.sourceforge.jenesis4java.impl.util;

/**
 * Copyright (C) 2008, 2010 Richard van Nieuwenhoven - ritchie [at] gmx [dot] at
 * Copyright (C) 2000, 2001 Paul Cody Johnston - pcj@inxar.org <br>
 * This file is part of Jenesis4java. Jenesis4java is free software: you can
 * redistribute it and/or modify it under the terms of the GNU Lesser General
 * Public License as published by the Free Software Foundation, either version 3
 * of the License, or (at your option) any later version.<br>
 * Jenesis4java is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.<br>
 * You should have received a copy of the GNU Lesser General Public License
 * along with Jenesis4java. If not, see <http://www.gnu.org/licenses/>.
 */
import java.util.List;

import net.sourceforge.jenesis4java.CodeWriter;
import net.sourceforge.jenesis4java.Codeable;

/**
 * BlockStyle is an interface whose implementations encapsulate the ability to
 * render an array of codeable objects with surrounding braces. This is
 * applicable for a number of stuctures including some declarations (classes,
 * methods...) and block statements. This allows a sort of 'plug and play'
 * approach to brace styles.
 */
public interface BlockStyle {

    /**
     * Sets an List of codeables to write as a block.
     */
    void toCode(CodeWriter out, List<? extends Codeable> codeables);
}
